(define (hexa_val conf)
  (cond
   ((and (char<=? #\0 conf) (char<=? conf #\9))
    (- (char->integer conf) (char->integer #\0)))

   ((and (char<=? #\a conf) (char<=? conf #\f))
    (+ (- (char->integer conf) (char->integer #\a)) 10))

   ((and (char<=? #\A conf) (char<=? conf #\F))
    (+ (- (char->integer conf) (char->integer #\A)) 10))
   (else
    0)))


(define (decode str)
  (define (iter lst)
    (if (null? lst)
	'()
	(cond
	 ((and (equal? #\% (car lst)) (>= (length lst) 3))
	  (cons (integer->char (+ (* 16 (hexa_val (list-ref lst 1))) 
				  (hexa_val (list-ref lst 2))))
		(iter (cdddr lst))))

	 ((equal? #\+ (car lst))
	  (cons #\space (iter (cdr lst))))
	 
	 (else
	  (cons (car lst) (iter (cdr lst)))))))
  (list->string (iter (string->list str))))

   
    
    
(define (replace str)
  (define (iter lst)
    (if (null? lst)
	'()
	(cond 
	 ((equal? (car lst) #\<)
	  (append (string->list "&lt;") (iter (cdr lst))))
	 ((equal? (car lst) #\>)
	  (append (string->list "&gt;") (iter (cdr lst))))
	 ((equal? (car lst) #\newline)
	  (append (string->list "<br>") (iter (cdr lst))))
	 (else
	  (cons (car lst) (iter (cdr lst)))))))
  (list->string (iter (string->list str))))
	 


(define (split-string str sep)
  (define (iter lst)
    (if (null? lst)
	'()
	(let ((hd (car lst))
	      (tail (iter (cdr lst))))
	  (if (equal? sep hd)
	      (cons '() tail)
	      (if (null? tail)
		  (cons (list hd) tail)
		  (let ((thd (car tail))
			(ttail (cdr tail)))
		    (cons (cons hd thd) ttail)))))))
  (map list->string (iter (string->list str))))



(define (read-stdin n)
  (define (iter n)
    (if (<= n 0)
	'()
	(let ((c (read-char)))
	  (if (eof-object? c)
	      '()
	      (cons c (iter (- n 1)))))))
  (list->string (iter n)))


(define (getQueryString)
  (let ((m (getenv "REQUEST_METHOD")))
    (if (equal? m "POST")
	(let ((len (string->number (getenv "CONTENT_LENGTH"))))
	  (read-stdin len))
	(getenv "QUERY_STRING"))))


(define (getArgs)
  (let* ((str (getQueryString))
	 (arglst (split-string str #\&)))
    (map (lambda (x)
	   (let ((buf (split-string x #\=)))
	     (cons (car buf) (replace (decode (cadr buf)))))) arglst)))


(define (read-mess)
  (define (iter)
    (let ((m (read)))
      (if (eof-object? m)
	  '()
	  (cons m (iter)))))
  
  (with-input-from-file "data/messages.txt" iter))

(define (write-mess mess)
  (define (iter lst)
    (if (not (null? lst))
	(begin
	  (write (car lst))
	  (newline)
	  (iter (cdr lst)))))
  
  (with-output-to-file "data/messages.txt" (lambda () (iter mess))))



; ---------- start cgi -------------

;(display "Content-Type: text/html;charset=euc-jp\n\n")



(define args (getArgs))

(define newmes 
  (list (cdr (assoc "title" args)) 
	(cdr (assoc "name" args)) 
	(cdr (assoc "content" args))))

(write-mess (cons newmes (read-mess)))


(display "Status: 302 Found\n")
(display "Location: bbs.cgi\n")
  
